/*******************************************************************
 Copyright (C) 2011-2024  Patrick H. E. Foubet - S.E.R.I.A.N.E.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>
*******************************************************************/

/* gestion niveau de trace */
#include <stdio.h>
#include <stdarg.h>

#include "trace.h"
#include "lich.h"

static int Trace=0;

/* ### les niveaux de trace */
#define TMIN 0
#define TMAX 3
#define T1 getTrace() > 0
#define T2 getTrace() > 1
#define T3 getTrace() > 2

void setTrace(int v) { Trace = v; }

int incrTrace(int v) {
   Trace += v;
   if (Trace < TMIN) { Trace = TMIN; return -1; }
   if (Trace > TMAX) { Trace = TMAX; return -1; }
   return 0;
}

int getTrace(void) { return Trace; }

void prTrace(void) { printf(Y(i12),getTrace()); }

void trace(int N,const char * f, ...)
{
va_list args;
    if (N>Trace) return;
    va_start(args, f);
    printf(Y(f48),N);
    vprintf(f, args);
    va_end(args);
}

void Tdebug(const char * f, ...)
{
va_list args;
   if (DebugOn==0) return;
   va_start(args, f);
   printf(Y(k14));
   vprintf(f, args);
   va_end(args);
}

